﻿function sign(x){
	if (x > 0){
		return 1;
	} else	if (x == 0){
		return 0;
	} else	
		return -1;
}

function LogInfo(Text){
	if(GSController.GetSetting("log_level") >= 2)
		Log.Info(Text, Log.LVL_DEBUG);
}


function LogDebugInfo(Text){
	if(GSController.GetSetting("log_level") >= 4)
		Log.Info(Text, Log.LVL_DEBUG);
}

function LogDebugError(Text){
		Log.Error(Text, Log.LVL_INFO);
}

function LogDebugWarning(Text){
	if(GSController.GetSetting("log_level") >= 3)
		Log.Warning(Text, Log.LVL_DEBUG);
}

function SleepIfSlowBuild(amount){
	if(GSController.GetSetting("BUILD_SPEED") >= 1)
		this.Sleep(amount);
}

function Sqrt(x){
	//x		1	16	64	144		256		400		625		10000	1000000		100000000
	//ret	1	4	8	12		16		20		25		100		1000		10000
	//
	if		(x < 1)			return	x
	else if (x < 16)		return  1 		+ 	3	*(x-1)		/(16-1)
	else if (x < 64)		return  4 		+ 	4	*(x-16)		/(64-16)
	else if (x < 144)		return  8 		+ 	4	*(x-64)		/(144-64)
	else if (x < 256)		return  12 		+ 	4	*(x-144)	/(256-144)
	else if (x < 400)		return  16 		+ 	4	*(x-256)	/(400-256)
	else if (x < 625)		return  20 		+ 	5	*(x-400)	/(625-400)		
	else if (x < 10000)		return  25 		+ 	75	*(x-625)	/(10000-625)		
	else if (x < 1000000)	return  100 	+ 	900	*(x-10000)	/(1000000-10000)
	else if (x < 100000000)	return  1000 	+ 	9000*(x-1000000)	/(100000000-1000000)
	else					return  10000 	+ 	x / 10000
}

function SuscessCount(x){
	if (x)
		return 1
	else
		return 0;
}

function ArrContains(arr, val) {
	for (local i = 0; i < arr.len(); i++)
		if (val == arr[i])
			return true
	
	//return (arr.find(val) != null)
	return false
}

function CanBuildIndustry(INDUSRTY_ID){
	local can_build = GSIndustryType.CanBuildIndustry(INDUSRTY_ID)
	local can_prospect = GSIndustryType.CanProspectIndustry(INDUSRTY_ID)	
	return can_build
}


// tile find helper
class RandomJumper {
	cx = 0
	cy = 0
	range_min = 0
	range_max = 0
	
 }
function RandomJumper::Jump(){
	local range = range_max - range_min
	local dx = GSBase.RandRange(range * 2) - range
	local dy = GSBase.RandRange(range * 2) - range
	dx += sign(dx) * range_min
	dy += sign(dy) * range_min		
		
	local x = this.cx + dx
	local y = this.cy + dy
	return GSMap.GetTileIndex(x, y)
}
 
function RandomJumper::Start(Tile, r_min, r_max){	
	this.cx = GSMap.GetTileX(Tile)
	this.cy = GSMap.GetTileY(Tile)
	this.range_min = r_min.tointeger()
	this.range_max = r_max.tointeger()
	//LogDebugInfo("Jumper is ready in x: " + cx + " y: " + cy + " range_min: " + range_min + " range_max: " + range_max)
}

function DecToOne(x){
	if (x > 1)
		return --x
	else
		return 1
}

function HasChangedMuch(a, b){
	if (b == 0)
		return	(a != 0)
	else
		return (fabs(fabs(a/b) - 1) >= 0.1);	
}

function LogIfDynamicChanged(name, after){
	local MULTI = GSController.GetSetting("SOME_MULTIPLIER") / 10
	local before = GSController.GetSetting(name) * MULTI
	if (HasChangedMuch(before, after))
		LogDebugWarning(name + " was blocking generator and changed to: " + after);
}

function PadRight(val, length){
	local str = val.tostring()
	for (local i = str.len(); i < length; i++)
		str += " "
	
	return str
}
